﻿package extras {
	
	import Box2DAS.*;
	import Box2DAS.Collision.*;
	import Box2DAS.Collision.Shapes.*;
	import Box2DAS.Common.*;
	import Box2DAS.Dynamics.*;
	import Box2DAS.Dynamics.Contacts.*;
	import Box2DAS.Dynamics.Joints.*;
	import cmodule.Box2D.*;
	import wck.*;
	import misc.*;
	import flash.utils.*;
	import flash.events.*;
	import flash.display.*;
	import flash.text.*;
	import flash.geom.*;
	import flash.ui.*;
	
	/**
	 * Base crayon class - doesn't create any shapes.
	 */
	public class Crayon extends BodyShape {	
		
		public var lineThickness:Number = 5;
		public var lineColor:Number = 0xffffff;
		
		var tracer:XYTracer;
		
		var source:XYSource;

		public override function create():void {
			type = 'Static';
			super.create();
			tracer = new XYTracer(source);
			tracer.addPoint(new Point(0, 0), false);
			tracer.localTo = this;
			listenWhileVisible(tracer, XYTracer.TEMP_POINT, onTempPoint);
			listenWhileVisible(tracer, XYTracer.PERM_POINT, onPermPoint);
			listenWhileVisible(tracer, XYTracer.FINISHED, onFinished);
		}
		
		public function onTempPoint(e:Event):void {
			onPoint(e);
		}
		
		public function onPermPoint(e:Event):void {
			onPoint(e);
		}
		
		public function onPoint(e:Event):void {
			graphics.clear();
			graphics.lineStyle(lineThickness, lineColor);
			graphics.drawGraphicsData(Vector.<IGraphicsData>([tracer.path]));
		}
				
		public function onFinished(e:Event):void {
			listenWhileVisible(world, StepEvent.STEP, updateBodyMatrixSimple, false, -10);
		}
	}
}